﻿using System;

namespace ELTE.Basics.SimpleStack
{
    class Stack // verem osztály
    {
        private Single[] values; // a megvalósítás rejtett
        private Int32 top;

        public Stack(Int32 maxSize) // konstruktor
        { 
            values = new Single[maxSize];
            top = 0;
        }

        public void Push(Single v)
        {
            if (top < values.Length)
            {
                values[top] = v;
                top++; // méret növelés
            }
            else
                throw new OverflowException("The stack is already full.");
        }

        public void Pop()
        {
            if (top > 0)
                top--; // méret csökkentése
            else
                throw new OverflowException("The stack is already empty.");
        }

        public Single Top // lekérdező tulajdonság
        { 
            get
            {
                if (top > 0) return values[top - 1];
                else throw new OverflowException();
            }
        }

        public Int32 Size { get { return top; } }

    }
}
