﻿using System;
using System.Collections.Generic;
using System.IO;

namespace ELTE.Basics.NumberTypes
{
    class Program
    {
        static void Main(string[] args)
        {
            Double d1 = 111, d2 = 4.1;
            Complex c1 = new Complex(2.5, 11.25);
            Console.WriteLine("Komplex szám: " + c1);
            Console.WriteLine("{0} + {1} = {2}", c1, d1, c1 + d1); // itt a komplex, valós paraméteres összeadást hívjuk meg
            Console.WriteLine("{0} + {1} = {2}", d2, c1, d2 + c1); // itt a valós, komplex paraméteres összeadást hívjuk meg
            Console.WriteLine();

            Rational r1 = new Rational(2, 3);
            Rational r2 = new Rational(5, 4);
            Rational r3 = new Rational(10, 5);

            Console.WriteLine("Racionális szám: " + r1);
            Console.WriteLine("{0} + {1} = {2}", r1, r2, r1 + r2);
            Console.WriteLine("{0} * {1} = {2}", r1, r3, r1 * r3);
            Console.WriteLine("{0} + {1} = {2}", c1, r2, c1 + (Double)r2); // konverziós operátor használata
            Console.WriteLine();

            Double sum = 0;
            List<IRealCompatible> rcList = new List<IRealCompatible>(); // polimorfizmussal tároljuk a számokat egy listában
            rcList.Add(c1);
            rcList.Add(r1);
            rcList.Add(r2);
            rcList.Add(r3);
            foreach (IRealCompatible rc in rcList)
                sum += rc.ToDouble(); // az interfész műveletét hívjuk meg, ténylegesen a megvalósított művelet fut le
            Console.WriteLine("Összes szám valós összege: " + sum);

            Console.ReadKey();
        }
    }
}
